#include "Menu.h"
#include "Carrera.h"
#include "MyFont.h"
#include "Jukebox.h"
#include "Confirm.h"
#include "Loading.h"
#include "EnterName.h"
#include "SelectionWheel.h"
#include "TrackSelection.h"
#include "RaceResults.h"
#include "RaceExtras.h"
#include "Particulas.h"
#include <iomanip>
#include "TextViewer.h"
#include "Shader.h"
#include <sstream>
#include "Circuito.h"
#include "RaceMenu.h"
#include "version.h"
#include "BikeSelection.h"
#include "ChampionshipMenu.h"
#include "Config.h"
#include "Profile.h"
using namespace std;

Menu::Menu() {
	load_fade;
	my_global_scale=0; Reload();
	Reset();
	Fade(true);
	
	help[mim_quickrace][0]="      start racing right now";
	help[mim_quickrace][1]="      on a random track with";
	help[mim_quickrace][2]="                a random bike.";
	help[mim_career][0]="win races and championships";
	help[mim_career][1]="    to improve your bike and";
	help[mim_career][2]="        unlock new features.";
	help[mim_options][0]="   tune graphics and sound";
	help[mim_options][1]="   to fit your system and get";
	help[mim_options][2]="the best performance/quality.";
	help[mim_about][0]="read some random stuff about";
	help[mim_about][1]="the game, its development and";
	help[mim_about][2]="find how to contact the author";
	help[mim_exit][0]="   stop loosing your time, get";
	help[mim_exit][1]="      out of this game, and do";
	help[mim_exit][2]="  something usefull... or not?";
	
	help[mim_practice][0]="   select a track and test your";
	help[mim_practice][1]="bike and your skills in a private";
	help[mim_practice][2]="session, without opponents around";
	help[mim_single_race][0]="participate in a complete race";
	help[mim_single_race][1]="weekend (practice, qualify and";
	help[mim_single_race][2]=" race) in any track you choose";
	help[mim_championship][0]=" race on all tracks and get more";
	help[mim_championship][1]="  points than any other racer to";
	help[mim_championship][2]="raice the cup an became a master";
	help[mim_setup_bike][0]="use the experience points that";
	help[mim_setup_bike][1]="you earned in races to improve";
	help[mim_setup_bike][2]="   your bike and became faster";
	help[mim_help_career][0]=" ";
	help[mim_help_career][1]="  more help about career mode";
	help[mim_help_career][2]=" ";
	help[mim_change_profile][0]=" if the title of this menu is";
	help[mim_change_profile][1]="not your name, use this option";
	help[mim_change_profile][2]="to return to profile selection";
	
	
	help[mim_sound][0]="turn on and off music and/or";
	help[mim_sound][1]="sound effects like the bike's";
	help[mim_sound][2]=" engine, crashes and people";
	
	help[mim_particles][0]="choose a level for graphics fx";
	help[mim_particles][1]="  like dust, sparks, shadows,";
	help[mim_particles][2]="reflexions and special shaders";
	
	help[mim_textures][0]="   if you have had problems to see";
	help[mim_textures][1]="tracks or bikes in an old machines,";
	help[mim_textures][2]="choose low textures and try again";
	
	help[mim_mode][0]="toggle fullscreen/windowed mode";
	help[mim_mode][1]="  and change the window size or";
	help[mim_mode][2]="          screen resolution";
	
	
	for (int i=0;i<profile_max;i++) {
		help[mim_count+i][0]="select <new profile> if it's your first";
		help[mim_count+i][1]="time. if it's not, choose your name to";
		help[mim_count+i][2]="continue, or press delete to remove it";
	}
	
}

void Menu::Reload() {
	if (my_global_scale==global_scale) return;
	my_global_scale=global_scale;
	lsprite.SetImage(loading->image);
	lw=loading->image.GetWidth(); lh=loading->image.GetHeight();
	lsprite.SetCenter(lw/2,lh/2); lsprite.SetSubRect(IntRect(0,0,lw,lh));
	load_wh(m1,fix_image_file("data/menu/menu1.png"),1,1);
	load_wh(m2,fix_image_file("data/menu/menu2.png"),1,1);
	load_wh(s,fix_image_file("data/menu/sel.png"),1,4); 
	load_wh(b,fix_image_file("data/menu/back.png"),1,1);
	load_wh(bl,fix_image_file("data/menu/baloon.png"),1,1);
	font->Reload(); race_extras->Reload(); sel_weel->Reload();
	humo->Reload(); marca->Reload(); chispa->Reload(); tierra->Reload(); lluvia->Reload();
	loading->Reload();
}

void Menu::Reset(bool all) {
	
	if (config->music_on) music->PlayMusic();
	
	FloatRect rect(0,0,screen_w,screen_h);
	view->SetFromRect(rect);
	App->SetView(*view);
	
	if (all) {
		second_x=850; second_y=120;
		show_help=false;
		in_options=false;
		last_move_time=0;
		prev_menu=prev_quit;
		second_w=0; show_second=false;
		
		bsprite.SetPosition(screen_w/2,screen_h/2);
		m1sprite.SetPosition(mx=screen_w/4,my=3*screen_h/4);
		main_h=0.05;
		main_done=false;
		
		items[mim_quickrace]="QUICKRACE";
		items[mim_career]="CAREER";
		items[mim_options]="OPTIONS";
		items[mim_about]="ABOUT";
		items[mim_exit]="EXIT";
		items[mim_practice]="PRACTICE";
		items[mim_single_race]="SINGLE RACE";
		items[mim_championship]="CHAMPIONSHIP";
		items[mim_setup_bike]="BIKE SETUP";
		items[mim_change_profile]="CHANGE PROFILE";
		items[mim_help_career]="HELP!";
		items[mim_sound]="Sound";
		items[mim_particles]="Graphics FX";
		items[mim_textures]="Textures";
		items[mim_mode]="Video Mode";
		ReloadOptions();
		
		for (int i=0;i<mim_count+profile_max;i++) 
			align_right[i]=false;
		for (int i=0;i<mim_count+profile_max;i++) {
			sel_level[i]=0;
			selected[i]=false;
			visible[i]=false;
			charsdone[i]=0;
		}
		for (int i=mim_quickrace;i<=mim_exit;i++) {
			visible[i]=true;
			tostart[i]=i*5*char_speed+40;
			pos[i][0]=mx-m1w/2*my_global_scale+140;
			pos[i][1]=my-m1w/2*my_global_scale+62+(45)*(i+1);
		}
		for (int i=mim_practice;i<=mim_help_career;i++) {
			pos[i][0]=screen_w-250;
			pos[i][1]=140+(55)*(i-mim_practice+1);
		}
		for (int i=mim_count;i<mim_count+profile_max;i++) {
			pos[i][0]=screen_w-250;
			pos[i][1]=140+(45)*(i-mim_count+1);
			if (i<mim_count+data->profile_count)
				items[i]=data->profile_names[i-mim_count];
		}
		for (int i=mim_sound;i<=mim_mode;i+=2) {
			pos[i][0]=screen_w-250;
			pos[i][1]=140+(45)*(i-mim_sound+1);
			pos[i+1][0]=screen_w-10;
			pos[i+1][1]=140+(45)*(i-mim_sound+2);
			align_right[i+1]=true;
		}
		selection=mim_career;
		lsprite.SetPosition(screen_w/4,screen_h/6);
	}
}

void Menu::Main() {
	while(App->IsOpened()) {
		
		sf::Event event;
		while(App->GetEvent(event)) {
			if(event.Type == event.Closed) {
				music->StopMusic(); Fade(false); loading->Draw(); App->Close();
			} if(App->GetInput().IsKeyDown(sf::Key::Escape) && last_key!=sf::Key::Escape) {
				if (config->sound_on) music->snd_selcancel.Play();
				last_key=sf::Key::Escape; SelCancel();
			} else if(App->GetInput().IsKeyDown(sf::Key::Return) && last_key!=sf::Key::Return) {
				last_key=sf::Key::Return; SelOk();
			} else if(App->GetInput().IsKeyDown(sf::Key::Up) && last_key!=sf::Key::Up) {
				last_key=sf::Key::Up; SelMove(true);
			} else if(App->GetInput().IsKeyDown(sf::Key::Down) && last_key!=sf::Key::Down) {
				last_key=sf::Key::Down; SelMove(false);
			} else if(App->GetInput().IsKeyDown(sf::Key::Left) && last_key!=sf::Key::Left) {
				last_key=sf::Key::Left; SelSide(false);
			} else if(App->GetInput().IsKeyDown(sf::Key::Right) && last_key!=sf::Key::Right) {
				last_key=sf::Key::Right; SelSide(true);
			} else if(App->GetInput().IsKeyDown(sf::Key::Delete) && last_key!=sf::Key::Delete) {
				last_key=sf::Key::Delete; Delete();
			} else if(App->GetInput().IsKeyDown(sf::Key::H) && last_key!=sf::Key::H) {
				last_key=sf::Key::H; show_help=!show_help;
			} else if (!App->GetInput().IsKeyDown(last_key)) {
				last_key=sf::Key::Count;
			}
		}
		
		Draw();
			
		App->TimedDisplay();
	}
}

void Menu::Draw() {

	sel_target_y=pos[selection][1]-15;
	sel_target_x=pos[selection][0]-50;
	
	App->Draw(bsprite);

//	la+=.05;
//	real da=sin(la);
//	lsprite.SetScale(1+da/20,1-da/10);
	App->Draw(lsprite);
	
	if (main_h<m1h) { 
		main_h*=1.3;
		m1sprite.SetScale(my_global_scale,real(main_h)/m1h*my_global_scale);
	} else 
		m1sprite.SetScale(my_global_scale,my_global_scale);
	App->Draw(m1sprite);
	
	if (show_second && second_w<400) second_w+=25;
	else if (!show_second && second_w>0) second_w-=25;
	if (second_w) {
		m2sprite.SetPosition(screen_w-second_w+m2w/2*my_global_scale,30+m2h/2*my_global_scale);
		App->Draw(m2sprite);
		if (second_x!=screen_w-second_w+60) second_x=(3*second_x+screen_w-second_w+60)/4;
		if (second_y!=120) second_y=(4*second_y+120)/5;
		font->RenderSmall(second_x,second_y,.8,second_title.c_str());
	}
	
	
	if (main_done) sel_weel->Draw(pos[selection][0],pos[selection][1]);
	
	for (int i=0;i<mim_count+data->profile_count;i++) {
		if (!visible[i]) continue;
		if (selected[i]) {
			if (sel_level[i]<8) sel_level[i]+=1;
		} else {
			if (sel_level[i]>0) sel_level[i]-=1;
		}
		if (align_right[i])
			font->RenderPartialI(pos[i][0]-sel_level[i],pos[i][1]+sel_level[i],.55+.035*sel_level[i],items[i],charsdone[i]/char_speed);
		else
			font->RenderPartial(pos[i][0]-sel_level[i],pos[i][1]+sel_level[i],.55+.035*sel_level[i],items[i],charsdone[i]/char_speed);
		if (charsdone[i]==char_speed*items[i].size()) continue;
		if (tostart[i]) { tostart[i]--; continue; }
		charsdone[i]++;
		if (!main_done && i==mim_exit && charsdone[mim_exit]==items[mim_exit].size()*char_speed) {
			main_done=true;
			selected[selection]=true;
		}
	}
	
	if (show_help && help[selection][0].size() && last_move_time++>15) {
		if (selection<=mim_exit) {
			blsprite.FlipX(false);
			blsprite.SetScale(my_global_scale,my_global_scale);
			blsprite.SetPosition(sel_target_x+300,sel_target_y-50);
		} else {
			blsprite.FlipX(true);
			blsprite.SetScale(1.3*my_global_scale,my_global_scale);
			blsprite.SetPosition(sel_target_x-100,sel_target_y-50);
		}
		App->Draw(blsprite);
		if (selection<=mim_exit) {
			font->RenderSmall(sel_target_x+250,sel_target_y-80,.5,help[selection][0].c_str());
			font->RenderSmall(sel_target_x+250,sel_target_y-45,.5,help[selection][1].c_str());
			font->RenderSmall(sel_target_x+250,sel_target_y-10,.5,help[selection][2].c_str());
		} else {
			font->RenderSmall(sel_target_x-420,sel_target_y-80,.5,help[selection][0].c_str());
			font->RenderSmall(sel_target_x-420,sel_target_y-45,.5,help[selection][1].c_str());
			font->RenderSmall(sel_target_x-420,sel_target_y-10,.5,help[selection][2].c_str());
		}
	}
	
	if (main_h>=m1h)
		font->RenderSmall(515,590,.4,"press H key for help baloons");
	font->RenderSmall(705,50,.4,VERSION);
	font->RenderSmall(700,25,.4,"still beta");
	
}

void Menu::SelMove(bool up) {
	if (config->sound_on) music->snd_selmove.Play();
	last_move_time=0;
	if (in_options) {
		if (up) {
			if (selection!=mim_sound) {
				selected[selection]=false;
				selected[selection+1]=false;
				selection-=2;
				selected[selection]=true;
				selected[selection+1]=true;
			}
		} else {
			if (selection!=mim_mode) {
				selected[selection]=false;
				selected[selection+1]=false;
				selection+=2;
				selected[selection]=true;
				selected[selection+1]=true;
			}
		}
	} else 
	if (up) {
		if (selection!=mim_quickrace && selection!=mim_count && selection!=mim_practice) {
			selected[selection]=false;
			selected[--selection]=true;
		}
	} else {
		if (selection!=mim_exit && selection!=mim_count+data->profile_count-1 && selection!=mim_help_career) {
			selected[selection]=false;
			selected[++selection]=true;
		}
	}
}

void Menu::SelCancel() {
	if (config->sound_on) music->snd_selcancel.Play();
	if (in_options) {
		if (config->old_fullscreen!=config->fullscreen||config->old_mode!=config->cur_mode) {
			delete App;
			App=new MyRenderWindow();
			App->SetView(*view);
		}
		if (config->music_on) music->PlayMusic(); else music->StopMusic();
		Reload(); config->Save();
	}
	last_move_time=0;
	if (prev_menu==prev_main) {
		selected[selection]=false;
		if (selection>=mim_sound && selection<=mim_mode) selected[selection+1]=false;
		for (int i=mim_quickrace;i<=mim_exit;i++)
			if (selected[i])
				selection=i;
		prev_menu=prev_quit;
		in_options=false;
	} else if (prev_menu==prev_quit) {
		if (confirm->Ask(this,"Leave The Game?")) {
			music->StopMusic();
			Fade(false);
			loading->Draw();
			App->Close();
		} else {
			FloatRect rect(0,0,screen_w,screen_h);
			view->SetFromRect(rect);
			App->SetView(*view);
		}
	}
}

void Menu::SelOkMain() {
	if (selection==mim_quickrace) {
		Fade(false);
		loading->Draw();
//		App->SetFramerateLimit(0);
		if (profile) {
			data->SelectProfile();
			ViewSecond("Choose your profile",mim_count,mim_count+data->profile_count);
			prev_menu=prev_quit;
			selected[selection]=false;
			selection=mim_quickrace;
		}
		racers=new Racer[data->bike_count];
		int the_one = rand()%data->bike_count;
		int *nums=new int[data->bike_count];
		for (int i=0;i<data->bike_count;i++) nums[i]=i;
		for (int i=0;i<data->bike_count-1;i++) {
			int aux,rnd=i+rand()%(data->bike_count-i);
			aux=nums[i]; nums[i]=nums[rnd]; nums[rnd]=aux;
		}
		for (int i=0;i<data->bike_count;i++) {
			if (nums[i]==the_one)
				racers[i].SetUnnamedPlayer(nums[i]);
			else
				racers[i].SetRandom(nums[i],1);
		}
		delete nums;
		for (int i=0;i<data->bike_count-1;i++) {
			int r=rand()%(data->bike_count-i);
			Racer aux = racers[i];
			racers[i] = racers[r];
			racers[r] = aux;
		}
#ifdef DEBUG		
		carrera = new Carrera(0,1);
#else
		carrera = new Carrera(rand()%data->track_count,3);
#endif
//		App->SetFramerateLimit(FPS);
		if (!circuito->IsOk()) {
			Fade(true);
			confirm->Tell2(this,"Can't load big textures. Go to","options and select low textures");
			delete carrera;
			return;
		}
		bool done=carrera->Race();
		loading->Draw();
		carrera->DeleteSomething();
		if (done) {
			loading->Draw();
			RaceResults *results = new RaceResults();
			results->Calculate(carrera);
			results->Show();
			loading->Draw();
			delete results;
		}
		delete carrera; carrera=NULL;
		delete [] racers; racers=NULL;
		Reset(false);
		Fade(true);
	} else if (selection==mim_career) {
		if (profile) {
			ViewSecond(profile->name,mim_practice,mim_help_career);
		} else {
			if (data->profile_count==1) {
				string pname = confirm->Input(this,"Enter your name:");
				if (pname.size()) {
					string pfile = data->NewProfile(pname);
					items[profile_max]=pname;
					ReloadProfiles();
					data->SelectProfile(pfile);
					ViewSecond(profile->name,mim_practice,mim_help_career);
				}
			} else {
				ViewSecond("Choose your profile",mim_count,mim_count+data->profile_count);
			}
		} 
	} else if (selection==mim_options) {
		ViewSecond("MotoGT Settings",mim_sound,mim_mode_value);
		selected[mim_sound_value]=true;
		selection=mim_sound;
		in_options=true;
	} else if (selection==mim_about) {
		Fade(false);
		TextViewer *text_viewer = new TextViewer("data/menu/about.png","About The Game...",text_about);
		text_viewer->Show(); delete text_viewer;
		Fade(true);
	} else if (selection==mim_exit) {
		SelCancel();
	}
}

void Menu::SelOkProfile() {
	if (selection==mim_change_profile) {
		data->SelectProfile();
		ViewSecond("Choose your profile",mim_count,mim_count+data->profile_count);
	} else if (selection==mim_championship) {
		Fade(false);
		ChampionshipMenu *champ_menu = new ChampionshipMenu();
		champ_menu->Run();
		delete champ_menu;
//		TextViewer *text_viewer = new TextViewer("data/menu/help.png","Championship Mode",text_help_championship);
//		text_viewer->Show(); delete text_viewer;
		Fade(true);
	} else if (selection==mim_help_career) {
		Fade(false);
		TextViewer *text_viewer = new TextViewer("data/menu/help.png","Career Mode",text_help_career);
		text_viewer->Show(); delete text_viewer;
		Fade(true);
	} else if (selection==mim_setup_bike) {
		Fade(false);
		BikeSelection *bike_selection = new BikeSelection(true);
		bike_selection->Select(1);
		delete bike_selection;
		Fade(true);
	} else if (selection==mim_single_race) {
		Fade(false);
		TrackSelection *track_selection = new TrackSelection();
		if (track_selection->Select(2)) {
			loading->Draw();
			delete track_selection;
			RaceMenu *race_menu = new RaceMenu(TrackSelection::target_track, TrackSelection::laps, TrackSelection::level);
			race_menu->Run();
			delete race_menu;
		} else 
			delete track_selection;
		Fade(true);
	} else if (selection==mim_practice) {
		Fade(false);
		loading->Draw();
		TrackSelection *track_selection = new TrackSelection();
		if (track_selection->Select(0)) {
			loading->Draw();
//			App->SetFramerateLimit(0);
			delete track_selection;
			circuito = new Circuito(TrackSelection::target_track);
			racers=new Racer[1];
			racers[0].SetFromProfile(0);
			carrera = new Carrera(50,1,true);
//			App->SetFramerateLimit(FPS);
			carrera->Race();
			loading->Draw();
			delete carrera; carrera=NULL;
			delete circuito; circuito=NULL;
			delete [] racers; racers=NULL;
		} else 
			delete track_selection;
		Fade(true);
	}
}

void Menu::SelOkOptions(bool up) {
	if (selection==mim_sound) {
		config->ChangeSound(up);
		ReloadOptions();
	} else if (selection==mim_mode) {
		config->ChangeMode(up);
		ReloadOptions();
	} else if (selection==mim_textures) {
		config->ChangeTextures(up);
		ReloadOptions();
	} else if (selection==mim_particles) {
		config->ChangeParticles(up);
		ReloadOptions();
	}
}

void Menu::SelOk() {
	if (config->sound_on) music->snd_selok.Play();
	last_move_time=0;
	if (selection>=mim_quickrace && selection<=mim_exit) SelOkMain();
	else if (selection>=mim_sound && selection<=mim_mode) SelOkOptions(true);
	else if (selection>=mim_practice && selection<=mim_help_career) SelOkProfile();
	else if (selection>=mim_count) {
		string pfile = data->profile_files[selection-mim_count];
		while (!pfile.size()) {
			string pname = confirm->Input(this,"Enter your name:");
			if (pname.size()) {
				if (data->ProfileExists(pname))
					confirm->Tell(this,"Profile name already in use.","Choose another one.");
				else {
					pfile = data->NewProfile(pname);
					ReloadProfiles();
				}
			} else return;
		}
		second_x=screen_w-250;
		second_y=140+(45)*(selection-mim_count+1);
		data->SelectProfile(pfile);
		ViewSecond(profile->name,mim_practice,mim_help_career);
	}
}

void Menu::SelSide(bool right) {
	if (config->sound_on) music->snd_selmove.Play();
	if (selection>=mim_sound && selection<=mim_mode) SelOkOptions(right);
}

void Menu::ReloadProfiles() {
	for (int i=mim_count;i<mim_count+data->profile_count;i++) {
		visible[i]=true;
		if (items[i]!=data->profile_names[i-mim_count]) {
			charsdone[i]=0;
			items[i]=data->profile_names[i-mim_count];
			tostart[i]=0;
		}
	}
	for (int i=mim_count+data->profile_count;i<mim_count+profile_max;i++) {
		visible[i]=false;
		charsdone[i]=0;
		items[i]="";
		if (selected[i] && selection==i) {
			selection=mim_count+data->profile_count-1;
			selected[mim_count+data->profile_count-1]=true;
		}
	}
	
}
void Menu::ViewSecond(string title, int i1, int i2, int is) {
	if (prev_menu==prev_quit)
		selected[selection]=true;
	else
		selected[selection]=false;
	show_second=true;
	second_title=title;
	for (int i=mim_sound;i<mim_count+profile_max;i++) {
		if (i<i1||i>i2) {
			visible[i]=false; charsdone[i]=0;
		} else {
			visible[i]=true; tostart[i]=(i-i1)*5*char_speed+(400-second_w)/25;
		}
	}
	selection=is?is:i1;
	selected[selection]=true;
	prev_menu=prev_main;
}

void Menu::ReloadOptions() {
	
	string sound="<quiet>";
	if (config->music_on&&config->sound_on) sound="<music+fx>";
	else if (config->sound_on) sound="<fx>";
	else if (config->music_on) sound="<music>";
	if (sound!=items[mim_sound_value]) { items[mim_sound_value]=sound; charsdone[mim_sound_value]=1; tostart[mim_sound_value]=0;}
	
	string particles="<custom>";
	if (!config->shaders_on && !config->extra_fx && config->particles_low==0 && config->particles_hi==0)
		particles="<none>";
	else if (!config->shaders_on && !config->extra_fx && config->particles_low==50 && config->particles_hi==100)
		particles="<low>";
	else if (!config->shaders_on && config->extra_fx && config->particles_low==100 && config->particles_hi==300)
		particles="<normal>";
	else if (!config->shaders_on && config->extra_fx && config->particles_low==250 && config->particles_hi==600)
		particles="<high>";
	else if (config->shaders_on && config->extra_fx && config->particles_low==250 && config->particles_hi==600)
		particles="<extreme>";
	if (particles!=items[mim_particles_value]) { items[mim_particles_value]=particles; charsdone[mim_particles_value]=0; tostart[mim_particles_value]=0;}
	if (sound!=items[mim_sound_value]) { items[mim_sound_value]=sound; charsdone[mim_sound_value]=1; tostart[mim_sound_value]=0; }

	string textures=config->low_textures?"<low>":"<normal>";
	if (textures!=items[mim_textures_value]) { items[mim_textures_value]=textures; charsdone[mim_textures_value]=1; tostart[mim_textures_value]=0;}
	
	stringstream smode;
	smode<<"<"<<config->real_w<<"x"<<config->real_h<<(config->fullscreen?"fs":"w")<<">";
	string mode=smode.str();
	if (mode!=items[mim_mode_value]) { 
		if (items[mim_mode_value].size()>mode.size() 
			&& items[mim_mode_value].substr(0,mode.size()-2)==mode.substr(0,mode.size()-2))
				charsdone[mim_mode_value]=mode.size()-2;
		else if (items[mim_mode_value].size()<mode.size() 
			&& items[mim_mode_value].substr(0,mode.size()-3)==mode.substr(0,mode.size()-3))
				charsdone[mim_mode_value]=mode.size()-3;
		else charsdone[mim_mode_value]=1;
		items[mim_mode_value]=mode;  tostart[mim_mode_value]=0;
	}
	
}

void Menu::Delete() {
	if (selection<mim_count) return;
	string pfile = data->profile_files[selection-mim_count];
	if (!pfile.size()) return;
	if (confirm->Ask(this,"Delete profile?")) {
		data->DeleteProfile(selection-mim_count);
		for (int i=mim_count;i<mim_count+data->profile_count;i++) {
			charsdone[i]=0; items[i]=data->profile_names[i-mim_count];
		}
		visible[mim_count+data->profile_count]=false;
		selected[selection]=false;
		selection=mim_count+data->profile_count-1;
		selected[selection]=true;
	}
}

implement_fade(Menu)
