#include "OSD.h"
#include "global.h"
#include "Carrera.h"
#include "Moto.h"
#include "MyFont.h"

OSD *osd;

OSD::OSD() {
	
	timage.LoadFromFile("data/osd/btime.png");
	tsprite.SetImage(timage);
	tw=timage.GetWidth();
	th=timage.GetHeight();
	
	vimage.LoadFromFile("data/osd/speed.png");
	vsprite.SetImage(vimage);
	vw=vimage.GetWidth()/2;
	vh=vimage.GetHeight();
	vsprite.SetCenter(vw/2+2,vh/2-.5);
	
	bimage.LoadFromFile("data/osd/blap.png");
	bsprite.SetImage(bimage);
	bsprite.SetCenter(0,bimage.GetHeight());
	
}

void OSD::Reset() {
	vangle=0;
}

void OSD::Draw(real x, real y, real z) {

	vsprite.SetSubRect(IntRect(0,0,vw,vh));
	vsprite.SetRotation(0);
	vsprite.SetPosition(x+z*(screen_w-vw)/2,y+z*(screen_h-vh)/2);
	vsprite.SetScale(z,z);
	App->Draw(vsprite);
	vsprite.SetSubRect(IntRect(vw,0,vw+vw,vh));
	vsprite.SetRotation(-3.7*moto_target->vangle);
	App->Draw(vsprite);

	bsprite.SetScale(z,z);
	bsprite.SetPosition(x-z*(screen_w/2-5),y+z*(screen_h/2-7));
	App->Draw(bsprite);
	font->RenderSmall(x-z*(screen_w/2-14),y+z*(screen_h/2-50),z/2.25,"Lap: ",moto_target->lap,"/",carrera->laps);
	
	carrera->Sort();
	if (!carrera->qualy_mode) {
		for (int i=0;i<carrera->num_racers;i++) {
			if (head_label) {
				if (show_names)
					font->RenderSmall(motos[i]->x,motos[i]->y,.35*z,motos[i]->name.c_str());
				else
					font->RenderSmall(motos[i]->x,motos[i]->y,.5*z,i+1);
			}
		}
	}
	
	font->RenderSmall(x-z*(screen_w/2-14),y+z*(screen_h/2-18),z/2.25,"Position:",moto_target->pos,"/",carrera->num_racers);

	tsprite.FlipX(false);
	tsprite.SetScale(z,z);
	tsprite.SetPosition(x-z*(screen_w/2),y-z*(screen_h/2));
	App->Draw(tsprite);
	tsprite.FlipX(true);
	tsprite.SetPosition(x+z*(screen_w/2-tw),y-z*(screen_h/2));
	App->Draw(tsprite);
	
	if (carrera->qualy_mode) {
		real tl = (carrera->timer-moto_target->clock_lap)*TIMER_CTE;
		font->RenderTime(x-z*(screen_w/2-14),y-z*(screen_h/2-30),z/2.25,tl);
		if (racers[moto_target->pos-1].best_lap>0)
			font->RenderTime(x-z*(screen_w/2-14),y-z*(screen_h/2-60),z/2.25,racers[moto_target->pos-1].best_lap);
		
		if (moto_target->pos>1) {
			font->RenderTime(x+z*(screen_w/2-80),y-z*(screen_h/2-30),z/2.25,racers[0].best_lap);
			font->RenderTime(x+z*(screen_w/2-80),y-z*(screen_h/2-60),z/2.25,racers[moto_target->pos-2].best_lap);
		}
		
	} else {
		if (moto_target->im_done)
			font->RenderTime(x-z*(screen_w/2-14),y-z*(screen_h/2-30),z/2.25,moto_target->time_total);
		else
			font->RenderTime(x-z*(screen_w/2-14),y-z*(screen_h/2-30),z/2.25,(carrera->timer-moto_target->clock_total)*TIMER_CTE);
		real tl = (carrera->timer-moto_target->clock_lap)*TIMER_CTE;
		if (moto_target->lap>1 && tl<5)
			font->RenderTime(x-z*(screen_w/2-14),y-z*(screen_h/2-60),z/2.25,moto_target->time_last_lap);
		else
			font->RenderTime(x-z*(screen_w/2-14),y-z*(screen_h/2-60),z/2.25,tl);

		if (moto_target->pos>1) {
			int in=moto_target->pos-2;
			if (show_names) {
				font->RenderSmall(x+z*(screen_w/2-10)-font->Ancho(motos[in]->name.c_str(),z/2.75),y-z*(screen_h/2-30),z/2.75,motos[in]->name.c_str());
			} else {
				int lapd=motos[in]->lap-moto_target->lap;
				if (motos[in]->check_next<moto_target->check_next) lapd--;
				else if (motos[in]->check_next==moto_target->check_next
					&& motos[in]->check_dist>moto_target->check_dist) lapd--;
				if (lapd>0)
					font->RenderSmall(x+z*(screen_w/2-80),y-z*(screen_h/2-30),z/2.25,lapd,"L");
				else {
					real diff = moto_target->times_last_partials[moto_target->check_next]-motos[in]->times_last_partials[moto_target->check_next];
					if (diff>0)	font->RenderSmall(x+z*(screen_w/2-80),y-z*(screen_h/2-30),z/2.25,diff);
				}
			} 
		}
		if (moto_target->pos<carrera->num_racers-1) {
			int ip=moto_target->pos;
			if (show_names) {
				font->RenderSmall(x+z*(screen_w/2-10)-font->Ancho(motos[ip]->name.c_str(),z/2.75),y-z*(screen_h/2-60),z/2.75,motos[ip]->name.c_str());
			} else {
				int lapd=moto_target->lap-motos[ip]->lap;
				if (motos[ip]->check_next>moto_target->check_next) lapd--;
				else if (motos[ip]->check_next==moto_target->check_next
					&& motos[ip]->check_dist<moto_target->check_dist) lapd--;
				if (lapd>0)
					font->RenderSmall(x+z*(screen_w/2-80),y-z*(screen_h/2-60),z/2.25,lapd,"L");
				else {
					real diff = motos[ip]->times_last_partials[motos[ip]->check_next]-moto_target->times_last_partials[motos[ip]->check_next];
					if (diff>0)	font->RenderSmall(x+z*(screen_w/2-80),y-z*(screen_h/2-60),z/2.25,diff);
				}
			}
		}
	}
	
}
